# Car object class for Kourier
# Ben Delacour Spring 2006

from __future__ import division
import glob
import helpers
import math
import os, os.path
import pygame
import random
import string
import sys
from GameObject import GameObject
from pygame.locals import *




class Car(GameObject):
    """Car object class for Kourier"""

    def __init__( self, pos_vec= [0, 0], direction= helpers.NORTH, speed=15 , filename= "car stripe green.PNG"):

        self.file_number= random.randint( 0, len(helpers.car_filenames)- 1 )
        filename= helpers.car_filenames[ self.file_number ]

        mov_vec= [0, 0]
        self.image_index= 0
        self.speed= speed
        self.grappled= False

        self.grapprect = Rect(0, 0, 60, 60)
        self.crashrect = Rect(0, 0, 30, 30)
        self.sentenced_to_death= False
        if direction == helpers.NORTH or direction == helpers.SOUTH: self.crashrect = Rect(0, 0, 22, 46)
        elif direction == helpers.EAST or direction == helpers.WEST: self.crashrect = Rect(0, 0, 46, 22)

        if   direction == helpers.NORTH: mov_vec= [0, -speed]; self.image_index= 0
        elif direction == helpers.SOUTH: mov_vec= [0,  speed]; self.image_index= 4
        elif direction == helpers.EAST:  mov_vec= [ speed, 0]; self.image_index= 2
        elif direction == helpers.WEST:  mov_vec= [-speed, 0]; self.image_index= 6

        GameObject.__init__(self, pos_vec, mov_vec)


    def sentence_to_death(self):
        self.sentenced_to_death= True



    def get_speed(self):
        return self.speed


    def set_speed(self, speed):
        self.speed= speed
        self.mov_vec= helpers.make_scaled_unit(self.mov_vec, self.speed)




    def update(self):
        self.crashrect.center= self.pos_vec
        self.grapprect.center= self.pos_vec

        GameObject.update(self)



    def get_index(self):
        return self.image_index




    def draw(self, background, imgnrect_arr, x, y):

                    car_img_arr_image= imgnrect_arr[self.image_index]
                    car_img_arr_rect=  car_img_arr_image.get_rect()
         
                    car_img_arr_rect.center = (x, y)
                    background.blit(car_img_arr_image, car_img_arr_rect)



    def isOB(self, width, height):
        if self.pos_vec[0] < 0 or \
           self.pos_vec[1] < 0 or \
           self.pos_vec[0] > width or \
           self.pos_vec[1] > height:
           return True
        return False



