# Generic game object class For Kourier
# Ben Delacour Spring 2006

import glob
import helpers
import math
import os, os.path
import pygame
import string
import sys
from pygame.locals import *




class GameObject:
    """A generic game object class for Kourier"""

    def __init__( self, pos_vec= [0, 0], mov_vec= [0, 0] ):
        self.pos_vec= pos_vec
        self.mov_vec= mov_vec
        self.prev_pos= pos_vec

    def update(self):
        self.prev_pos= self.pos_vec
        self.pos_vec= helpers.add_points(self.pos_vec, self.mov_vec)



    def set_pos(self, pos):
        self.pos_vec[0]= pos[0]
        self.pos_vec[1]= pos[1]
        
    def get_pos(self):
        return [self.pos_vec[0], self.pos_vec[1]]


    def get_x(self):
        return self.pos_vec[0]

    def get_y(self):
        return self.pos_vec[1]


    def get_pos_with_old_y(self):
        return [self.pos_vec[0], self.prev_pos[1]]

    def get_pos_with_old_x(self):
        return [self.prev_pos[0], self.pos_vec[1]]

    def go_back(self):
        self.pos_vec= self.prev_pos

    def use_y_movement_only(self):
        self.pos_vec= [self.prev_pos[0], self.pos_vec[1]]

    def use_x_movement_only(self):
        self.pos_vec= [self.pos_vec[0], self.prev_pos[1]]




    def rotate_mov(self, raddi):
        self.mov_vec= helpers.rotate_point(raddi)

    def make_mov_vec_unit(self, raddi):
        self.mov_vec= helpers.rotate_point(raddi)

    def distance_from_point(self, point):
        return helpers.distance(self.pos_vec, point)

    def add_point_to_pos(self, point):
        self.pos_vec= helpers.add_points(self.pos_vec, point)

    def add_point_to_mov(self, point):
        self.mov_vec= helpers.add_points(self.mov_vec, point)




