# Kourier
# Ben Delacour Spring/Summer 2006


from __future__ import division

import glob
import helpers
import high
import inputbox
import locale
import math
import os, os.path
import pygame
import random
import string
import sys
from GameObject import GameObject
from Level      import Level
from Player     import Player
from pygame.locals import *




def load_world_ini(name):
    # Loads world variables from world.ini

    ### defaults (if specified)
    _game_screen_x= 640
    _game_screen_y= 480
    _tile_dimen=    64
    _level_start=   "level1.lev"

    if os.path.exists(name) == False:
        print "%s doesn't exist!" % name
    else:
        fin= file(name, 'r')

    whole= fin.read()
    fin.close()
    lines= string.split(whole, '\n')

    for lin in lines:  

        a, b = string.split(lin, ':')
        if a == "game_screen_x":   _game_screen_x =   int(b)
        elif a == "game_screen_y": _game_screen_y =   int(b)
        elif a == "tile_dimen":    _tile_dimen =      int(b)
        elif a == "level_start":   _level_start = b

    return _game_screen_x, _game_screen_y, _level_start




def draw_world(tile_imgnrect_arr, tile_floor1_arr2d, tile_floor2_arr2d, \
                                                              background):
    g_level.draw_floor(tile_floor1_arr2d, tile_imgnrect_arr, background)
    g_level.draw_floor(tile_floor2_arr2d, tile_imgnrect_arr, background)
    g_level.draw_mail_objs(background);
    g_level.draw_cars(background);




def main():
    pygame.init()
    random.seed()
    
    global g_level
    global g_playa

    if not pygame.font: print 'Warning, fonts disabled'
    if not pygame.mixer: print 'Warning, sound disabled'

    game_screen_x, \
    game_screen_y, \
    start_level= load_world_ini('world.ini')

    g_level= Level()
    g_level.screen_size= [game_screen_x, game_screen_y]
    center_x=    g_level.screen_size[0]// 2
    center_y=    g_level.screen_size[1]// 2

    screen=      pygame.display.set_mode(g_level.screen_size, pygame.FULLSCREEN)
    background=  pygame.Surface(g_level.screen_size).convert()
    wheel_imgnrect= helpers.load_image(os.path.join("sprites", "wheel.PNG"), 0xFF0080)
    mainfont= helpers.get_default_font(25)
    
    locale.setlocale(locale.LC_ALL, 'English_United States.1252')   # For money float formatting (123,456.00)
    pygame.display.set_caption('Kourier')
    pygame.mouse.set_visible(0)

    g_playa= Player()
    g_level.load( start_level )
    g_playa.set_pos( g_level.player_start_pos )
    mode= "intro"


    running= True
    loaded= False
    paused= False
    levels_complete= False
    description_ticks= 60
    while running == True:
        pygame.time.delay(40)


        if mode == "play":
            if not loaded:
                loaded= True
                radar_chart_imgnrect=   helpers.load_image(os.path.join("sprites", "radar chart.PNG"), 0xFF0080)
                energy_bar_green_imgnrect= helpers.load_image(os.path.join("sprites", "energy bar green.PNG"), 0xFF0080)
                energy_bar_red_imgnrect=   helpers.load_image(os.path.join("sprites", "energy bar red.PNG"), 0xFF0080)

            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:

                    if True:    # Programmer's tools
                        if event.key == K_a:
                            if g_level.get_next_level() == start_level:
                                loaded= False
                                mode= "ending"
                                levels_complete= True
                                if g_playa.money > high.get_lowest_score(helpers.HIGH_SCORE_FILENAME):
                                        loaded= False
                                        mode= "enter name"
                                        next_mode= "ending"
                            else:
                                loaded= False
                                mode= "description"
                                g_level.load( g_level.get_next_level() )
                                g_playa.has_parcel= False
                                g_playa.Reset(g_level.player_start_pos)

                        if event.key == K_i:
                            print "main.py, car floor:"
                            for row in g_level.car_floor_arr2d:
                                print row
                            print "explosion array:", g_level.explosions_arr2d


                    if event.key == K_SPACE:
                        if not g_playa.grappled:
                            g_playa.shoot_grapple()
                        else:
                            g_playa.release_grapple()
                            g_level.release_grappled_car()
 
                    elif event.key == K_LEFT:
                        g_playa.left=     True
                        g_playa.left_ex=  True
                        g_playa.right=    False

                    elif event.key == K_RIGHT:
                        g_playa.right=    True
                        g_playa.right_ex= True
                        g_playa.left=     False

                    elif event.key == K_UP:
                        g_playa.up=       True
                        g_playa.up_ex=    True
                        g_playa.down=     False

                    elif event.key == K_DOWN:
                        g_playa.down=     True
                        g_playa.down_ex=  True
                        g_playa.up=       False

                    elif event.key == K_RALT or event.key == K_LALT:
                        g_playa.brakes= True


                    elif event.key == K_p:
                        loaded= False
                        mode= "paused"

                    elif event.key == K_ESCAPE or event.key == K_q:
                        loaded= False
                        mode= "paused"

                    elif event.key == K_p:
                        loaded= False
                        mode= "paused"



                elif event.type == KEYUP:

                    if event.key == K_LEFT:
                        g_playa.left=     False
                        g_playa.left_ex=  False

                    elif event.key == K_RIGHT:
                        g_playa.right=    False 
                        g_playa.right_ex= False 

                    elif event.key == K_UP:
                        g_playa.up=       False
                        g_playa.up_ex=    False

                    elif event.key == K_DOWN:
                        g_playa.down=     False
                        g_playa.down_ex=  False

                    elif event.key == K_RALT or event.key == K_LALT:
                        g_playa.brakes= False





            if g_playa.grappled and not g_level.get_grappled_car().grappled:
                g_playa.release_grapple()
                g_level.release_grappled_car()

            if g_playa.grappled == True:
                g_playa.update_grappled( g_level.get_grappled_car(), g_level);
            else: g_playa.update()
  

            for i in range( 0, len(g_level.car_arr) ):
                ### car-border collisions
                if g_playa.crashrect.colliderect(g_level.car_arr[i].crashrect):

                    if not g_playa.is_invincible():
                        g_playa.make_invincible()
                        crash_vec= helpers.sub_points(g_playa.mov_vec, g_level.car_arr[i].mov_vec)
                        g_playa.damage+= .05* math.hypot( crash_vec[0], crash_vec[1] )
                        g_level.explosions_arr2d.append([g_playa.get_x(), g_playa.get_y(), \
                        5, helpers.create_explosion(20, min_len= 10, \
                        low_scale= .4, sections= 10), (208, 189, 51)])
                       

                ### grapple connect detection
                if not g_playa.grappled and g_playa.grapple_vec!= [0, 0]:
                    # below: if not more than one eighth in a different direction
                    if (  abs(g_level.car_arr[i].get_index()- g_playa.get_shooting_index()) <= 2 \
                       or abs(g_playa.get_shooting_index()- g_level.car_arr[i].get_index()) >= 6 )\
                       and ( g_level.car_arr[i].grapprect.collidepoint( g_playa.get_grapple_world_pt() )\
                          or g_level.car_arr[i].grapprect.collidepoint( g_playa.get_half_grapple_world_pt() )):

                        g_playa.attach_grapple(g_level.car_arr[i], g_level)
                        g_level.set_grappled_car(i)


            ### damage (keywords: strength energy health)
            if g_playa.damage >= 1.0:
                g_playa.lives-= 1
                if g_playa.has_parcel:
                    g_level.invalidate_bonus_potential()
                    g_level.explosions_arr2d= []
                else:
                    g_level.parcel_pick_up_time+= 40* 10  # 10 second penalty should...
                         # ...be enough to make it a waste of time to intentionally die
                    
                if g_playa.lives < 0:
                    if g_playa.money > high.get_lowest_score(helpers.HIGH_SCORE_FILENAME):
                        loaded= False
                        mode= "seeing stars"
                        next_mode= "enter name"
                    else:
                        loaded= False
                        mode= "seeing stars"
                        next_mode= "game over"
                else:
                    loaded= False
                    mode= "seeing stars"
                    next_mode= "play"
                    g_playa.Reset( g_level.player_start_pos )



            # OK terrain:
            if g_level.get_special_at_pos( g_playa.get_pos() ) == helpers.SP_OK:
                g_playa.on_OK_terrain= True
            else :
                g_playa.on_OK_terrain= False
        
            # X'ed out tile: cannot enter:
            if g_level.get_special_at_pos( g_playa.get_pos() ) == helpers.SP_X:

                speed= math.hypot( g_playa.mov_vec[0], g_playa.mov_vec[1] )
                hurt_distance_vec= helpers.sub_points( g_playa.location_hurt, g_playa.get_pos() )
                hurt_distance= math.hypot( hurt_distance_vec[0], hurt_distance_vec[1] )
                
                # try only moving y
                if g_level.get_special_at_pos( g_playa.get_pos_with_old_x() ) != helpers.SP_X:
                    g_playa.use_y_movement_only()

                # try only moving x
                elif g_level.get_special_at_pos( g_playa.get_pos_with_old_y() ) != helpers.SP_X:
                    g_playa.use_x_movement_only()

                else:
                    g_playa.go_back()
                    if math.hypot(g_playa.grapple_vec[0], g_playa.grapple_vec[1])> g_playa.grapple_max_len:
                        g_playa.release_grapple()
                        g_level.release_grappled_car()

                ### player "brick wall style" damage
                if g_playa.image_index% 2 == 0:
                    if speed > g_playa.reg_speed* 1.1 and hurt_distance > speed+1:
                        if not g_playa.is_invincible():
                            g_playa.make_invincible()
                            g_playa.damage+= .015* (speed- g_playa.reg_speed)
                            g_playa.mov_vec= helpers.scale(g_playa.mov_vec, .7)
                            g_playa.location_hurt= g_playa.get_pos()
                            g_level.explosions_arr2d.append([g_playa.get_x(), g_playa.get_y(), \
                               5, helpers.create_explosion(20, min_len= 10, \
                                  low_scale= .4, sections= 10), (208, 189, 51)])


            ### Checkpoint check:
            if g_level.get_special_at_pos( g_playa.get_pos() ) == helpers.SP_CHECK_TRIGGER:
                g_level.player_start_pos= g_level.player_checkpoint_pos


            ### Parcel pick up and delivery
            if g_level.is_at_parcel( g_playa.get_pos() ):
                pick_up_penalty= g_level.parcel_pick_up_time* .1
                g_level.pick_up_parcel()
                g_playa.has_parcel= True

            if g_playa.has_parcel and g_level.is_at_mailbox( g_playa.get_pos() ):
                bonus= ((g_level.bonus_time_arr[g_level.cur_parcel- 1]* 40)- g_level.parcel_delivery_time)/ 40*1.3
                if bonus < 0 or not g_level.can_get_bonus():
                    bonus= 0
                g_playa.money+= 5+ bonus
                g_playa.money_str= "$"+locale.format("%.2f", g_playa.money, grouping=True)
                g_level.last_bonus= bonus
                g_level.last_bonus_str= "$"+locale.format("%.2f", bonus, grouping=True)
                #print "bonus:", bonus
                g_level.drop_off_parcel()
                g_playa.has_parcel= False;

                if g_level.finished_delivering():
                    if g_level.get_next_level() == start_level:
                        loaded= False
                        mode= "ending"
                        levels_complete= True
                        if g_playa.money > high.get_lowest_score(helpers.HIGH_SCORE_FILENAME):
                                loaded= False
                                mode= "enter name"
                                next_mode= "ending"
                    else:
                        g_level.load( g_level.get_next_level() )
                        damage= g_playa.damage
                        g_playa.Reset( g_level.player_start_pos )
                        g_playa.damage= damage
                        loaded= False
                        mode= "description"
                        continue

            g_level.set_screen_center_pos( g_playa.get_pos() )
            g_level.update()
            
            
            
            

            ############### draw level #####################
            draw_world(g_level.tile_imgnrect_arr, g_level.tile_floor1_arr2d, \
                                 g_level.tile_floor2_arr2d, background)
            g_playa.draw(background, center_x, center_y, g_level.get_grappled_car())

                          
            helpers.glow_text(background, mainfont, g_playa.money_str, \
                  g_level.screen_size[0]-75, 10, (0, 64, 0), (255, 255, 255), 2)

            if not g_level.finished_delivering():
                radar_chart_imgnrect[1].center= 600, 40
                background.blit(radar_chart_imgnrect[0], radar_chart_imgnrect[1])

                
                energy_bar_green_imgnrect[1].topleft= 15, 15
                background.blit(energy_bar_green_imgnrect[0], energy_bar_green_imgnrect[1])

                damage_start= 71-(g_playa.damage*71)
                energy_bar_red_imgnrect[1].topleft= 19+damage_start, 19
                portion= pygame.Rect(damage_start, 0, 71, 17)
                background.blit(energy_bar_red_imgnrect[0], energy_bar_red_imgnrect[1], portion)


                helpers.glow_text(background, mainfont, "lives: "+ str(g_playa.lives), \
                                 80, 45, (0, 64, 0), (255, 255, 255), 2)

                ### display bonus $ for a time
                if g_level.parcel_pick_up_time < 35:
                    x= g_level.mailbox_pos_arr[g_level.cur_mailbox- 1][0]
                    y= g_level.mailbox_pos_arr[g_level.cur_mailbox- 1][1]
                    prev_mail_x= x*g_level.tile_dimen- g_level.screen_pos[0]+40
                    prev_mail_y= y*g_level.tile_dimen-g_level.screen_pos[1]
                    helpers.glow_text(background, mainfont, "+ $5.00", \
                           prev_mail_x, prev_mail_y-20, (0, 0, 0), (255, 128, 64), 2)
                    if g_level.last_bonus >= .1:
                        helpers.glow_text(background, mainfont, "+ "+g_level.last_bonus_str, \
                               prev_mail_x, prev_mail_y, (0, 0, 0), (255, 0, 128), 2)


                radar_color=  [255,000,000]
                radar_vector= [640-30, 30]
                if not g_playa.has_parcel:
                    target= g_level.get_parcel_loc()* g_level.tile_dimen;
                else:
                    target= g_level.get_mailbox_loc()* g_level.tile_dimen;
                    radar_color=  [000,128,255]

                target= helpers.add_points(target, [g_level.tile_dimen/2, g_level.tile_dimen/2] );
                player= g_playa.get_pos();
                radar_vector= [target[0]- player[0], target[1]- player[1]]
                radar_vector= helpers.scale(radar_vector, 1/20)

                if math.hypot(radar_vector[0], radar_vector[1]) > 18:
                    radar_vector= helpers.make_unit(radar_vector);
                    radar_vector= helpers.scale(radar_vector, 18)

                radar_vector= helpers.add_points(radar_vector, radar_chart_imgnrect[1].center)
                radar_vector= helpers.intergerize_vec(radar_vector)

                white= [255, 255, 255]
                black= [0, 0, 0]
                light= [255, 255, 128]

                pygame.draw.circle(background, black, radar_vector, int(4) )
                pygame.draw.circle(background, radar_color, radar_vector, int(2) )
      


                if g_playa.grappled == True:

                    adjusted_grapple_vec= [-g_playa.grapple_vec[0], -g_playa.grapple_vec[1]]
                    car_dir=  g_level.get_grappled_car().image_index
                    rotation= 0
                    eighth=   math.pi/4
                    if   car_dir == 0: rotation= eighth* 6   # up
                    elif car_dir == 1: rotation= eighth* 5
                    elif car_dir == 2: rotation= eighth* 4   # right
                    elif car_dir == 3: rotation= eighth* 3
                    elif car_dir == 4: rotation= eighth* 2   # down
                    elif car_dir == 5: rotation= eighth* 1
                    elif car_dir == 6: rotation= eighth* 0   # left
                    elif car_dir == 7: rotation= eighth* 7
 
                    adjusted_grapple_vec= helpers.rotate_point(adjusted_grapple_vec, rotation)
                    angle= math.atan2(adjusted_grapple_vec[1], adjusted_grapple_vec[0])
                    angle_fraction= ((math.pi/g_playa.grappled_rotation_angle)/2)/1.5  #"/1.5" means 3/4 of the way (to 2)
                    g_playa.grapple_vec= helpers.rotate_point( g_playa.grapple_vec, -angle/angle_fraction )


            if (mode == "play"): screen.blit(background, (0,0))
            pygame.display.flip()

            #Exiting Main Loop



        elif mode == "description":
            if not loaded:
                loaded= True
                description_ticks= 60

                background.fill(0x000000)
                font= helpers.get_default_font(64)

                ### bottom layer of wavey text
                offset= [56, 176]
                colors= [(128, 128, 64), (208, 217, 43), (208, 217, 43)]
                positions= [[0, 0], [2, 2], [3, 3]]
                for i in range(0, len(colors)):
                    text= font.render(g_level.part_description+ ":", True, colors[i])
                    textpos= text.get_rect()
                    textpos.midleft= [ positions[i][0]+ offset[0], positions[i][1]+ offset[1] ]
                    background.blit(text, textpos)

                ### wavy mask top layer stuff
                text_mask_name= os.path.join("sprites", "text mask.PNG")
                text_mask= helpers.load_image(text_mask_name, 0x000000)
                wavy= pygame.Surface([640, 48]).convert()
                wavy.fill( 0x000000 )
                wavy.set_colorkey(0xFFFFFF, RLEACCEL)

                offset= [0, 24]
                colors= [(128, 128, 64), (208, 217, 43), (255, 255, 128)]
                positions= [[0, 0], [2, 2], [3, 3]]

                for i in range(0, 3):
                    text= font.render(g_level.part_description+ ":", True, colors[i])
                    textpos= text.get_rect()
                    textpos.midleft= [ positions[i][0]+ offset[0], positions[i][1]+ offset[1] ]
                    wavy.blit(text, textpos)

                wavy.blit(text_mask[0], [0, 20])
                wavy.fill( 0xFFFFFF, Rect(0, 34, 640, 48) )
 
                offset= [56, 176-24]
                background.blit(wavy, offset)

                ### part two description: bottom layer of wavey text
                offset= [575, 240]
                colors= [(126, 80, 33), (176, 143, 45), (208, 189, 51)]
                positions= [[0, 0], [2, 2], [3, 3]]
                for i in range(0, len(colors)):
                    text= font.render(g_level.description, True, colors[i])
                    textpos= text.get_rect()
                    textpos.midright= [ positions[i][0]+ offset[0], positions[i][1]+ offset[1] ]
                    background.blit(text, textpos)

                colors= [(128, 128, 64), (208, 217, 43), (255, 255, 128)]

                ### part two description: wavy mask top layer stuff
                wavy.fill( 0x000000 )

                offset= [575, 24]
                colors= [(126, 80, 33), (176, 143, 45), (255, 255, 128)]
                positions= [[0, 0], [2, 2], [3, 3]]

                for i in range(0, 3):
                    text= font.render(g_level.description, True, colors[i])
                    textpos= text.get_rect()
                    textpos.midright= [ positions[i][0]+ offset[0], positions[i][1]+ offset[1] ]
                    wavy.blit(text, textpos)

                wavy.blit(text_mask[0], [0, 20])
                wavy.fill( 0xFFFFFF, Rect(0, 34, 640, 48) )
 
                offset= [0, 240-24]
                background.blit(wavy, offset)

                
                screen.blit(background, (0,0))
                pygame.display.flip()



            description_ticks= description_ticks- 1
            if description_ticks <= 0:
                background.fill(0x000000)
                loaded= False
                mode=   "play"






        elif mode == "highscore":
            if not loaded:
                loaded= True
                
                highscore_options= ["return"]
                highscore_entry= 0
                title_imgnrect=  helpers.load_image(os.path.join("sprites", "highscores title.PNG"))
                title_imgnrect[1].topleft= 100, 30
                menu_imgnrect=  helpers.load_image(os.path.join("sprites", "scoreboard menu.PNG"))
                menu_imgnrect[1].topleft= 70, 378

                background.fill(0x000000)
                background.blit(title_imgnrect[0], title_imgnrect[1])

                name_arr, score_arr= high.read_high_scores("high scores.txt")

                font= helpers.get_default_font(35)
                for i in range(0, len(name_arr)):
                    ### Display name and score

                    message= str(i+1)+":  "+name_arr[i]
                    helpers.glow_text_ex(background, font, message,\
                           165, i*(32)+ 120, (100, 20, 10), (200, 20, 10), 1)

                    message= "$"+locale.format("%.2f", score_arr[i], grouping=True)
                    text_width= font.size(message)[0]
                    helpers.glow_text_ex(background, font, message,\
                           465- text_width, i*(32)+ 120, (100, 20, 10), (200, 29, 80), 1)

            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE or event.key == K_RETURN or event.key == K_KP_ENTER:
                        if (highscore_options[highscore_entry] == "return"):
                            loaded= False
                            mode= next_mode
                            
            wheel_imgnrect[1].topleft= 39, 403+ highscore_entry* 36
            background.blit(menu_imgnrect[0], menu_imgnrect[1])
            background.blit(wheel_imgnrect[0], wheel_imgnrect[1])

            screen.blit(background, (0,0))
            pygame.display.flip()




        elif mode == "intro":
            if not loaded:
                loaded= True
                intro_options= ["play", "info", "exit"]
                intro_entry= 0
                title_imgnrect= helpers.load_image(os.path.join("sprites", "title.PNG"))
                title_imgnrect[1].topleft= 30, 50
                parcel_imgnrect=  helpers.load_image(os.path.join("sprites", "radi parcel.PNG"))
                parcel_imgnrect[1].topleft= 330, 284
                menu_imgnrect=  helpers.load_image(os.path.join("sprites", "intro menu.PNG"))
                menu_imgnrect[1].topleft= 70, 264


            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        running= False

                    if event.key == K_DOWN:
                        intro_entry+= 1
                        if intro_entry >= len(intro_options): intro_entry= 0

                    if event.key == K_UP:
                       intro_entry-= 1
                       if intro_entry < 0: intro_entry= len(intro_options)- 1

                    elif event.key == K_RETURN or event.key == K_KP_ENTER:
                        if (intro_options[intro_entry] == "play"):
                            loaded= False
                            mode= "description" # mode= "play"
                        if (intro_options[intro_entry] == "info"):
                            loaded= False
                            mode= "info"
                        if (intro_options[intro_entry] == "exit"):
                            running= False
                            
            wheel_imgnrect[1].topleft= 65, 289+ intro_entry* 36
            background.fill(0x000000)
            background.blit(title_imgnrect[0], title_imgnrect[1])
            background.blit(parcel_imgnrect[0], parcel_imgnrect[1])
            background.blit(menu_imgnrect[0], menu_imgnrect[1])
            background.blit(wheel_imgnrect[0], wheel_imgnrect[1])
            screen.blit(background, (0,0))
            pygame.display.flip()



        elif mode == "info":
            if not loaded:
                loaded= True
                info_options= ["return", "highscore"]
                info_entry= 0
                title_imgnrect=  helpers.load_image(os.path.join("sprites", "info title.PNG"))
                title_imgnrect[1].topleft= 30, 30
                objective_imgnrect=  helpers.load_image(os.path.join("sprites", "objective.PNG"))
                objective_imgnrect[1].topleft= 57, 155
                menu_imgnrect=  helpers.load_image(os.path.join("sprites", "info menu.PNG"))
                menu_imgnrect[1].topleft= 43, 328
                control_imgnrect=  helpers.load_image(os.path.join("sprites", "kbdsm.PNG"))
                control_imgnrect[1].topleft= 355, 321

                background.fill(0x000000)
                background.blit(control_imgnrect[0], control_imgnrect[1])
                background.blit(title_imgnrect[0], title_imgnrect[1])
                background.blit(objective_imgnrect[0], objective_imgnrect[1])

                if os.path.exists("info.ini") == False:
                    print "%s doesn't exist!" % name
                else:
                    fin= file("info.ini", 'r')
                whole= fin.read()
                line_arr= string.split(whole, '\n')

                font= helpers.get_default_font(21)
                for i in range(0, len(line_arr)):
                    ### Display line of text
                    text= font.render(line_arr[i], True, (200, 89, 10))
                    textpos= text.get_rect()
                    textpos.topleft= 227, i*(16)+ 30
                    background.blit(text, textpos)

            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE or event.key == K_RETURN or event.key == K_KP_ENTER:
                        if (info_options[info_entry] == "return"):
                            loaded= False
                            if paused: mode= "paused"
                            else:      mode= "intro"

                        if (info_options[info_entry] == "highscore"):
                            loaded= False
                            mode= "highscore"
                            next_mode= "info"

                    elif event.key == K_DOWN:
                        info_entry+= 1
                        if info_entry >= len(info_options): info_entry= 0

                    elif event.key == K_UP:
                       info_entry-= 1
                       if info_entry < 0: info_entry= len(info_options)- 1

                            
            wheel_imgnrect[1].topleft= 39, 353+ info_entry* 36
            background.blit(menu_imgnrect[0], menu_imgnrect[1])
            background.blit(wheel_imgnrect[0], wheel_imgnrect[1])

            screen.blit(background, (0,0))
            pygame.display.flip()




        elif mode == "game over":
            if not loaded:
                loaded= True
                gameOver_options= ["play again", "quit"]
                gameOver_entry= 0
                title_imgnrect=  helpers.load_image(os.path.join("sprites", "game over title.PNG"))
                title_imgnrect[1].center= 320, 120
                menu_imgnrect=  helpers.load_image(os.path.join("sprites", "game over menu.PNG"))
                menu_imgnrect[1].topleft= 205, 238

            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:

                    if event.key == K_ESCAPE:
                        running= False
                        continue

                    if event.key == K_RETURN or event.key == K_KP_ENTER:
                        if (gameOver_options[gameOver_entry] == "play again"):
                            loaded= False
                            mode= "description" # mode= "play" 
                            
                            g_level.load( start_level )
                            g_playa.game_over_reset( g_level.player_start_pos )

                        if (gameOver_options[gameOver_entry] == "quit"):
                                running= False
                                continue

                    if event.key == K_DOWN or event.key == K_KP2:
                        gameOver_entry+= 1
                        if gameOver_entry >= len(gameOver_options): gameOver_entry= 0

                    if event.key == K_UP or event.key == K_KP8:
                       gameOver_entry-= 1
                       if gameOver_entry < 0: gameOver_entry= len(gameOver_options)- 1

                            
            wheel_imgnrect[1].topleft= 200, 263+ gameOver_entry* 36
            background.fill(0x000000)
            background.blit(title_imgnrect[0], title_imgnrect[1])
            background.blit(menu_imgnrect[0], menu_imgnrect[1])
            background.blit(wheel_imgnrect[0], wheel_imgnrect[1])

            screen.blit(background, (0,0))
            pygame.display.flip()





        elif mode == "enter name":

            if not loaded:
                playscreen= background.copy() 
                title_imgnrect=  helpers.load_image(os.path.join("sprites", "enter name title.PNG"))
                menu_imgnrect=  helpers.load_image(os.path.join("sprites", "scoreboard menu.PNG"))
                menu_imgnrect[1].center= center_x, center_y+ 70
                title_imgnrect[1].center= center_x, center_y- 70
                loaded= True
                name_str=""
                name_length_limit= 8

            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:

                    if event.key == K_RETURN or event.key == K_KP_ENTER or event.key == K_ESCAPE:
                        if event.key == K_ESCAPE:
                            running= False

                        if name_str == "":
                            name_str= "???"
                            high.add_new_score(helpers.HIGH_SCORE_FILENAME, name_str, g_playa.money)
                            if not levels_complete:
                                loaded= False
                                mode= next_mode
                            else:
                                loaded= False
                                mode= "highscore"
                                next_mode= "ending"
                        else:
                            high.add_new_score(helpers.HIGH_SCORE_FILENAME, name_str, g_playa.money)
                            if not levels_complete:
                                loaded= False
                                mode= "highscore"
                            else:
                                loaded= False
                                mode= "highscore"
                                next_mode= "ending"

                    elif event.key == K_BACKSPACE:
                        name_str= name_str[:-1]
                    elif event.unicode:
                        if len(name_str) < name_length_limit:
                            name_str+= event.unicode    

            background.blit(playscreen, (0,0))

            pygame.draw.polygon(background, 0x000000, [[center_x, center_y-175], \
                                                       [center_x+175, center_y], \
                                                       [center_x, center_y+175], \
                                                       [center_x-175, center_y]])

            background.blit(title_imgnrect[0], title_imgnrect[1])
            background.blit(menu_imgnrect[0], menu_imgnrect[1])
            wheel_imgnrect[1].topleft= center_x- 55, center_y+ 67
            background.blit(wheel_imgnrect[0], wheel_imgnrect[1])
            helpers.draw_input_box( background, "Enter your name: ", name_str, text_size=20, \
                                    box_length=217, box_color=(255, 0, 128), fgcolor1=(255,128,0), \
                                    fgcolor2= (255,210,0) )
            screen.blit(background, (0,0))
            pygame.display.flip()





        elif mode == "paused":

            if not loaded:
                if not paused:
                    paused= True;
                    playscreen= background.copy() 
                title_imgnrect=  helpers.load_image(os.path.join("sprites", "paused title.PNG"))
                title_imgnrect[1].center= center_x, center_y- 80
                menu_imgnrect=  helpers.load_image(os.path.join("sprites", "intro menu.PNG"))
                menu_imgnrect[1].center= center_x, center_y+30
                pause_options= ["play", "info", "exit"]
                pause_entry= 0
                loaded= True

            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE or event.key == K_q:
                        if pause_entry!=2: pause_entry= 2
                    elif event.key == K_p or event.key == K_SPACE:
                        paused= False
                        mode= "play"

                    if event.key == K_DOWN or event.key == K_KP2:
                        pause_entry+= 1
                        if pause_entry >= len(pause_options): pause_entry= 0

                    if event.key == K_UP or event.key == K_KP8:
                        pause_entry-= 1
                        if pause_entry < 0: pause_entry= len(pause_options)- 1

                    elif event.key == K_RETURN or event.key == K_KP_ENTER:
                        if (pause_options[pause_entry] == "play"):
                            paused= False
                            mode= "play"
                        if (pause_options[pause_entry] == "info"):
                            loaded= False
                            mode= "info"
                        if (pause_options[pause_entry] == "exit"):
                            if g_playa.money > high.get_lowest_score(helpers.HIGH_SCORE_FILENAME):
                                loaded= False
                                mode= "enter name"
                                next_mode= "game over"
                            else:
                                running= False
         
            background.blit(playscreen, (0,0))

            #background.fill(0x000000, Rect(center_x-10, center_y, 20, center_y) )
            pygame.draw.polygon(background, 0x000000, [[center_x, center_y-175], \
                                                       [center_x+175, center_y], \
                                                       [center_x, center_y+175], \
                                                       [center_x-175, center_y]])

            background.blit(title_imgnrect[0], title_imgnrect[1])
            background.blit(menu_imgnrect[0], menu_imgnrect[1])
            wheel_imgnrect[1].topleft= center_x- 62, center_y- 22+ pause_entry* 36
            background.blit(wheel_imgnrect[0], wheel_imgnrect[1])
            screen.blit(background, (0,0))
            pygame.display.flip()





        elif mode == "seeing stars": 
            if not loaded:
                description_ticks= 8
                poly_scale=        0.3
                poly_scale_inc=     .8
                poly_orig= helpers.create_explosion(max_len= 200, min_len= 100, low_scale= .4, sections= 12)
                poly_rend= [poly_orig[0]]+poly_orig[1:]

                for i in range( len(poly_orig) ):
                    poly_rend[i]= helpers.add_points( [center_x, center_y], \
                                                      helpers.scale(poly_orig[i], poly_scale) )
                background.fill(0x000000)
                loaded= True

            old_poly= poly_rend[:]   # equiv. to old_poly= [poly_rend[0]]+poly_rend[1:]
            for i in range( len(poly_orig) ):
                poly_rend[i]= helpers.add_points( [center_x, center_y], \
                                                  helpers.scale(poly_orig[i], poly_scale) )
            poly_scale+= poly_scale_inc


            pygame.draw.polygon(background, (208, 0, 43), poly_rend)
            pygame.draw.polygon(background, (208, 217, 43), old_poly)
            screen.blit(background, (0,0))
            pygame.display.flip()

            
            if description_ticks < 0:
                loaded= False
                mode= next_mode
                if g_playa.lives < 0:  # damage (keywords: strength energy health)
                        next_mode= "game over"

            description_ticks-= 1





        elif mode == "end game":
            running= False


        elif mode == "ending":
            if not loaded:
                loaded= True
                background.fill(0x000000)
                
                title_imgnrect=  helpers.load_image(os.path.join("sprites", "silhouette.PNG"), [255,0,128])
                title_imgnrect[1].topleft= 0, 0
                menu_imgnrect=  helpers.load_image(os.path.join("sprites", "ending menu.PNG"))
                menu_imgnrect[1].topleft= 70, 378
                g_level.load( "ending.lev" )
                font= helpers.get_default_font(30)
                text= font.render("-Final Score: "+ g_playa.money_str+ "-", True, (222, 222, 222))
                textpos= text.get_rect()
                textpos.midtop= 320, 300
               
            for event in pygame.event.get():

                if event.type == QUIT:
                    running = False

                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE or event.key == K_RETURN or event.key == K_KP_ENTER:
                        g_level.load( start_level )
                        g_playa.game_over_reset( g_level.player_start_pos )
                        loaded= False
                        mode= "intro"
                        levels_complete= False
                        continue

            if levels_complete:
                g_level.update()

                g_level.draw_floor(g_level.tile_floor1_arr2d, g_level.tile_imgnrect_arr, background)
                g_level.draw_cars(background);
                background.blit(title_imgnrect[0], title_imgnrect[1])
                background.blit(text, textpos)


                wheel_imgnrect[1].topleft= 39, 403
                background.blit(menu_imgnrect[0], menu_imgnrect[1])
                background.blit(wheel_imgnrect[0], wheel_imgnrect[1])

                screen.blit(background, (0,0))
                pygame.display.flip()




if __name__ == '__main__': main()




